package pwc.taxtech.atms.vat.service;

import pwc.taxtech.atms.constant.enums.EnumServiceType;
import pwc.taxtech.atms.dpo.ReportDto;
import pwc.taxtech.atms.dto.OperationResultDto;
import pwc.taxtech.atms.dto.vatdto.CellTemplateReferenceDto;
import pwc.taxtech.atms.dto.vatdto.DataSourceDto;
import pwc.taxtech.atms.dto.vatdto.ManualDataSourceDto;
import pwc.taxtech.atms.dto.vatdto.ReportDataDto;
import pwc.taxtech.atms.dto.vatdto.VatEnterpriseAccountResultDto;
import pwc.taxtech.atms.vat.entity.PeriodCellTemplateConfig;
import pwc.taxtech.atms.vat.entity.VatEnterpriseAccount;

import java.util.List;
import java.util.Optional;

public interface ReportService {
    OperationResultDto<List<ReportDto>> getReportTemplate(String projectId, EnumServiceType serviceType, Integer period);

    OperationResultDto updateConfig(String projectId, Integer period, Boolean ifDeleteManualDataSource, String generator);

    OperationResultDto generateData(String projectId, EnumServiceType serviceType, Boolean ifDeleteManualDataSource,
                                    Integer periodParam, Integer reportType, Optional<String> generator);

    List<CellTemplateReferenceDto> getTemplateReferences(int period);

    OperationResultDto<ReportDataDto> getCellData(Long reportId, String porjectId);

    OperationResultDto<ReportDto> getReportByTemplate(Long templateId, Integer period, String projectId);

    OperationResultDto<PeriodCellTemplateConfig> getCellTemplateConfig(Long reportTemplateId, Integer periodParam,
                                                                       int rowIndex, int columnIndex,String porjectId);

    OperationResultDto<List<VatEnterpriseAccount>> getStdAccountByIndustry(String industryId,String projectId);

    OperationResultDto<List<VatEnterpriseAccountResultDto>> getCellAccountRange(Long reportTemplateId, Integer period, int rowIndex, int columnIndex,String projectId);

    /**
     * 添加手工数据源方法接口
     *
     * @param data 数据源数据
     * @return 添加结果
     */
    OperationResultDto addCellManualDataSource(ManualDataSourceDto data, String projectId);

    OperationResultDto<String> addDataSource(DataSourceDto datasource);

    OperationResultDto<String> getAllDataItems(Integer dataSourceType);

    OperationResultDto addDataSourceItems(DataSourceDto dataSource);

    OperationResultDto<String> getDataSourceDetailList(Long datasSourceId);
}
