﻿vatModule.controller('VatImportOutputInvoiceController', ['$scope', '$cookies', '$log', '$translate', '$timeout', 'apiInterceptor', 'Upload', 'vatImportService', 'SweetAlert', '$q', 'uiGridConstants', '$interval', 'vatSessionService', 'loginContext', 'browserService', 'enums', 'vatOperationLogService', 'projectService', 'vatCommonService',
    function ($scope, $cookies, $log, $translate, $timeout, apiInterceptor, Upload, vatImportService, SweetAlert, $q, uiGridConstants, $interval, vatSessionService, loginContext, browserService, enums, vatOperationLogService, projectService, vatCommonService) {
        'use strict';

        var successCount = 0;
        var uploadUrl = apiInterceptor.vatWebApiHostUrl + '/FileUpload/NewFile';
        var apiTokenObj = $cookies.getObject('AtmsApiToken');
        var webHost = apiTokenObj.api_host;
        var chunkSize = 100000;
        var resumable = true;
        var curPeriod = vatSessionService.month;
        var curYear = vatSessionService.project.year;
        var percentList = ['17%', '13%', '11%', '6%', '5%', '3%', '1.5%'];
        var comment = vatSessionService.project.name + " " + vatSessionService.project.year + "年" + vatSessionService.month + "月";
        var projectDbName = vatSessionService.project.dbName;

        //写日志
        $scope.period = vatSessionService.month;
        $scope.moduleid = enums.vatModuleEnum.Import_OutputInvoice;
        var logDto = {
            ID: '',
            OperationName: '',
            ModuleID: $scope.moduleid,
            OperationObject: $translate.instant('OutputInvoiceTitle'),
            OperationType: '',
            OperationContent: '',
            OriginalState: '',
            UpdateState: '',
            CreatorID: vatSessionService.logUser.ID,
            Comment: comment,
            IP: '',
            Period: $scope.period,
        };

        //初始化ack-pagination
        $scope.pagingOptions = {
            pageIndex: 1, //当前页码
            totalItems: 0, //总数据
            totalPages: 10, //总页数
            maxSize: 5, //分页数字的限制。
            pageSize: constant.page.pageSizeArrary[3], //每页多少条数据,100条
            pageSizeString: constant.page.pageSizeArrary[3].toString(),
            firstPage: $translate.instant('PagingFirstPage'),
            previousPage: $translate.instant('PagingPreviousPage'),
            nextPage: $translate.instant('PagingNextPage'),
            lastPage: $translate.instant('PagingLastPage'),
        };

        $scope.totalData = {
            totalNumber: 0,
            amount: 0,
            taxAmount: 0
        }


        $scope.downloadTemplatePath = webHost + '/Resource/ImportData/销项发票导入模板.xls';
        $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
        $scope.sheetInfo = { selectedSheetName: '', selectedSheetIndex: 0 };
        $scope.invoiceData = [];
        $scope.outputInvoiceList = [];
        $scope.outputInvoiceItemList = [];
        $scope.errorMsgMap = [];
        $scope.totalCount = 0;
        $scope.evidenceTotalCount = '';
        //初始化参数
        $scope.showErrorTable = false;
        $scope.showInitTable = false;
        $scope.showImportTable = false
        $scope.isShowImportTotalBtn = true;

        var validationErrorType = {
            InvoiceInfoEmptyCheckErrorType: $translate.instant('OutputInvoiceErrorType'),
            InvoiceDateErrorType: $translate.instant('InvoiceDateErrorType'),
            DateCheckErrorType: $translate.instant('InvoiceDateRangeCheckErrorType'),
            AmountNumberCheckErrorType: $translate.instant('AmountNumberCheckErrorType'),
            TaxAmountNumberCheckErrorType: $translate.instant('TaxAmountNumberCheckErrorType'),
            AuantityNumberCheckErrorType: $translate.instant('AuantityNumberCheckErrorType'),
            TaxRateCheckErrorType: $translate.instant('TaxRateCheckErrorType'),
            OutputStringLengthType: $translate.instant('OutputStringLengthType'),
            OutputInvoiceTypeErrorType: $translate.instant('OutputInvoiceTypeErrorType'),
        };

        var invoiceTypeEnum = {
            Normal: $translate.instant('Normal'),
            Special: $translate.instant('Special'),
        };

        //根据当前的月份获取当月第一天日期
        var getCurrentMonthFirstDay = function () {
            var curMonth = curPeriod;
            if (curPeriod < 10) {
                curMonth = '0' + curPeriod;
            }
            var oneDay = 1000 * 60 * 60 * 8;
            return new Date(new Date(curYear + '-' + curMonth + '-' + '01') - oneDay)
        };

        //根据当前的月份获取当月的最后一天日期
        var getCurrentMonthLastDay = function () {
            var curMonth = curPeriod;
            if (curPeriod < 10) {
                curMonth = '0' + curPeriod;
            }
            var date = new Date(curYear + '-' + curMonth + '-' + '01');
            var currentMonth = date.getMonth();
            var nextMonth = ++currentMonth;
            var nextMonthFirstDay = new Date(date.getFullYear(), nextMonth, 1);
            //var oneDay = 1000 * 60 * 60 * 16;
            //if (browserService.isIE() || browserService.isEdge())
            //{
            //    return new Date(nextMonthFirstDay);
            //}
            //else{
            //     return new Date(nextMonthFirstDay - oneDay);
            //}     
            return new Date(nextMonthFirstDay);
        };
        //导入方式
        $scope.importEnum = {
            Import: 0, CoverImport: 1, AddImport: 2
        };

        //上传文件
        var uploadfile = function (file) {
            if (file) {
                successCount = 0;
                if (!file.$error) {
                    var tempFileName = PWC.newGuid() + '.dat';
                    var token = $('input[name="__RequestVerificationToken"]').val();
                    Upload.upload({
                        url: uploadUrl,
                        data: {
                            cancel: false,
                            filename: file.name,
                            tempFileName: tempFileName,
                            file: file
                        },
                        resumeChunkSize: resumable ? chunkSize : null,
                        headers: {
                            'Access-Control-Allow-Origin': '*',
                            Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken()
                        },
                        __RequestVerificationToken: token,
                        withCredentials: true
                    }).then(uploadSuccess);
                }
            }
        };
        //上传成功
        var uploadSuccess = function (resp) {
            successCount++;
            if (successCount === 1) {
                $scope.tempFileName = resp.data;
                changeSheet(0);
            }
        };

        /****************************************销项发票function start*************************************************/
        //选择sheet
        function changeSheet(selectedSheet) {
            var sheetIndex = _.findIndex($scope.sheetData.sheetNameList, function (num) {
                return num.name === selectedSheet.name;
            })
            $scope.sheetInfo.selectedSheetIndex = sheetIndex === -1 ? 0 : sheetIndex;
            refreshTable();
        };

        //刷新列表
        function refreshTable() {
            $scope.showErrorTable = false;
            if (_.isString($scope.tempFileName)) {
                $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
                $scope.gridOptionsOutputInvoice.data = [];
                vatImportService.getFileContent($scope.tempFileName, $scope.sheetInfo.selectedSheetIndex, 0).success(function (data) {
                    if (data.result === false) {
                        $scope.showInitTable = true;
                        $scope.showImportTable = false;
                        initTableTitle();
                        SweetAlert.warning(data.resultMsg);
                    }
                    else {
                        $scope.showInitTable = false;
                        $scope.showImportTable = true
                    }
                    $scope.sheetData = data;
                    var sheetNameObjectArray = [];
                    data.sheetNameList.forEach(function (v) {
                        sheetNameObjectArray.push({ 'name': v });
                    });
                    $scope.sheetData.sheetNameList = sheetNameObjectArray;
                    $scope.sheetInfo.selectedSheetName = $scope.sheetData.sheetNameList[$scope.sheetInfo.selectedSheetIndex];
                    vatSessionService.dataChanged = true;
                    $scope.invoiceData = $scope.sheetData.dataList.slice(1, $scope.sheetData.dataList.length);
                    //加入index序号
                    var index = 1;
                    $scope.invoiceData.forEach(function (v) {
                        v.index = index++;
                    });
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        };

        //切换发票信息汇总和证据文件
        function switchTab(event) {
            $('.nav-tab span').each(function () {
                $(this).removeClass('active');
            });

            $(event.target).addClass('active');

            if (event.target.innerText == $translate.instant('OutputInvoiceTab')) {
                $('#tab_total').css('display', 'block');
                $('#tab_evidence').css('display', 'none');
            }
            else {
                $('#tab_total').css('display', 'none');
                $('#tab_evidence').css('display', 'block');
            }
        };

        //转换发票类型
        function translateInvoiceType(strType) {
            var type = 0;
            switch (strType) {
                case invoiceTypeEnum.Normal:
                    type = 0;
                    break;
                case invoiceTypeEnum.Special:
                    type = 1;
                    break;
                default:
                    type = 10;
            }
            return type;
        }

        //发票类型转换
        $scope.typeToString = function (strType) {
            var type = invoiceTypeEnum.Normal;
            switch (strType) {
                case 0:
                    type = invoiceTypeEnum.Normal;
                    break;
                case 1:
                    type = invoiceTypeEnum.Special;
                    break;
                default:
                    type = "";
            }
            return type;
        }

        //转换百分比
        $scope.decimalToPercent = function (data) {
            return (data * 100).toFixed(0) + "%";
        }

        //百分比转小数
        function translatePercentNum(per) {
            return per.replace(/([0-9.]+)%/, function (a, b) { return +b / 100; })
        }

        //转换没有选中的列值
        function undefinedToNull(inputData) {
            if (PWC.isNullOrEmpty(inputData)) {
                return 0;
            }
            else {
                return inputData;
            }
        }

        //验证导入是否符合模板
        function validationIsImportTemp() {
            //验证前，将错误数据清空
            var isOK = true;
            if ($.trim($scope.sheetData.dataList[0][0]) !== $translate.instant('InvoiceType')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][1]) !== $translate.instant('ClassCode')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][2]) !== $translate.instant('InvoiceNumber')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][3]) !== $translate.instant('BuyerName')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][4]) !== $translate.instant('BuyerTaxNumber')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][5]) !== $translate.instant('BankAccount')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][6]) !== $translate.instant('PhoneNum')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][7]) !== $translate.instant('InvoiceDate')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][8]) !== $translate.instant('CodeVersion')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][9]) !== $translate.instant('DocumentNum')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][10]) !== $translate.instant('ProductName')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][11]) !== $translate.instant('ProductStandar')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][12]) !== $translate.instant('Unit')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][13]) !== $translate.instant('Quantity')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][14]) !== $translate.instant('UnitPrice')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][15]) !== $translate.instant('Amount')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][16]) !== $translate.instant('TaxRate')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][17]) !== $translate.instant('TaxAmount')) {
                isOK = false;
            }
            if ($.trim($scope.sheetData.dataList[0][18]) !== $translate.instant('TaxClassCode')) {
                isOK = false;
            }
            return isOK;
        }

        //获取销项发票信息
        function getOutputInvoiceData() {
            var lastInvoiceDto = {};
            lastInvoiceDto.items = [];
            var count = 0;
            var invoiceInfoEmptyCheckMsg = '';
            for (var i = 1; i < $scope.sheetData.dataList.length; i++) {
                var invoiceDto = {};
                //销项
                if ($.trim($scope.sheetData.dataList[i][0]).length > 0 &&
                    $.trim($scope.sheetData.dataList[i][1]).length > 0 &&
                    $.trim($scope.sheetData.dataList[i][2]).length > 0) {
                    invoiceDto.InvoiceID = PWC.newGuid();
                    invoiceDto.InvoiceType = translateInvoiceType($.trim($scope.sheetData.dataList[i][0]));
                    invoiceDto.ClassCode = $scope.sheetData.dataList[i][1];
                    invoiceDto.InvoiceNumber = $scope.sheetData.dataList[i][2];
                    invoiceDto.BuyerName = $scope.sheetData.dataList[i][3];
                    invoiceDto.BuyerTaxNumber = $scope.sheetData.dataList[i][4];
                    invoiceDto.BankAccount = $scope.sheetData.dataList[i][5];
                    invoiceDto.PhoneNum = $scope.sheetData.dataList[i][6];
                    invoiceDto.InvoiceDate = $scope.sheetData.dataList[i][7];
                    invoiceDto.SeqNo = $scope.outputInvoiceList.length + 1;
                    invoiceDto.PeriodID = $scope.period;
                    invoiceDto.Status = 0;
                    invoiceDto.items = [];
                    invoiceDto.Index = i;

                    lastInvoiceDto = invoiceDto;
                    $scope.outputInvoiceList.push(invoiceDto);
                    getInvoiceItemData($scope.sheetData.dataList[i], lastInvoiceDto, i);
                }
                    //明细信息验证
                else if ($.trim($scope.sheetData.dataList[i][0]).length == 0 &&
                    $.trim($scope.sheetData.dataList[i][1]).length == 0 &&
                    $.trim($scope.sheetData.dataList[i][2]).length == 0) {
                    getInvoiceItemData($scope.sheetData.dataList[i], lastInvoiceDto, i);
                }
                else {
                    invoiceInfoEmptyCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: i }) + ')' + $translate.instant('OutputInvoiceErrorMsg') + '<br />';
                    count++;
                }
            }
            //1:发票代码，发票号码，发票类型要么全为空，要么都有数据
            if (count > 0) {
                $scope.errorMsgMap.push({
                    'errorType': validationErrorType.InvoiceInfoEmptyCheckErrorType,
                    'errorCount': count,
                    'errorContent': invoiceInfoEmptyCheckMsg
                });
            }

        }

        //获取明细信息
        function getInvoiceItemData(rowData, invoiceData, index) {
            var invoiceItemDto = {
            };
            //明细信息
            if ($.trim(rowData[10]) !== $translate.instant('Subtotal') && $.trim(rowData[10]) !== $translate.instant('Alltotal')) {
                invoiceItemDto.ItemID = PWC.newGuid();
                invoiceItemDto.ClassCode = invoiceData.ClassCode;
                invoiceItemDto.InvoiceNumber = invoiceData.InvoiceNumber;
                invoiceItemDto.InvoiceID = invoiceData.InvoiceID;
                invoiceItemDto.CodeVersion = rowData[8];
                invoiceItemDto.ProductName = rowData[10];
                invoiceItemDto.DocumentNum = rowData[9];
                invoiceItemDto.ProductStandard = rowData[11];
                invoiceItemDto.Unit = rowData[12];
                invoiceItemDto.Quantity = rowData[13];
                invoiceItemDto.UnitPrice = undefinedToNull(rowData[14]);
                invoiceItemDto.Amount = undefinedToNull(rowData[15]);
                invoiceItemDto.TaxRate = undefinedToNull(rowData[16]);
                invoiceItemDto.TaxAmount = undefinedToNull(rowData[17]);
                invoiceItemDto.SeqNo = invoiceData.items.length + 1;
                invoiceItemDto.TaxClassCode = rowData[18];
                invoiceItemDto.PeriodID = $scope.period;
                invoiceItemDto.Index = index;
                //加入上传列表
                invoiceData.items.push(invoiceItemDto);
                $scope.outputInvoiceItemList.push(invoiceItemDto);
            }
        }

        //销项发票前端验证
        function frontEndValidOutputInvoiceData() {
            //4.开票日期验证，不能为空，且格式正确
            var invoiceDateCheckMsg = '';
            var count1 = 0;
            //开票日期范围
            var invoiceDateRangeCheckMsg = '';
            var count2 = 0;
            //金额
            var amountNumberCheckMsg = '';
            var count3 = 0;
            //税额
            var taxAmountNumberCheckMsg = '';
            var count4 = 0;
            //数量
            var quantityCheckMsg = '';
            var count5 = 0;
            //税率
            var taxRateCheckMsg = '';
            var count6 = 0;
            //发票类别
            var typeMsg = '';
            var typeCount = 0;
            //长度验证
            var stringLengthMsg = '';
            var stringCount = 0;
            //数据长度
            var NumlengthMsg = '';
            var NumLengthCount = 0;
            //数量
            var unitPriceCheckMsg = '';
            var unitPriceCount = 0;

            $scope.outputInvoiceList.forEach(function (m) {
                //开票日期为空
                if (PWC.isNullOrEmpty(m.InvoiceDate)) {
                    invoiceDateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceDateNullMsg') + '<br />';
                    count1++;
                }
                    //日期格式错误
                else if (!PWC.checkDate(m.InvoiceDate)) {
                    invoiceDateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceDateErrorMsg') + '<br />';
                    count1++;
                }
                    //如果日期不在选定期间
                else {
                    if (!(new Date(m.InvoiceDate.replace(/[\.-]/g, '/')) >= getCurrentMonthFirstDay() && new Date(m.InvoiceDate.replace(/[\.-]/g, '/')) < getCurrentMonthLastDay())) {
                        invoiceDateRangeCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceDateRangeCheckErrorMsg') + '<br />';
                        count2++;
                    }
                }

                if (m.InvoiceType === 10) {
                    typeMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('OutputInvoiceTypeErrorMsg') + '<br />';
                    typeCount++;
                }
                if (PWC.getStringLength(m.ClassCode) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('ClassCode') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.InvoiceNumber) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('InvoiceNumber') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.BuyerName) > 100) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BuyerName') + $translate.instant('Output100LengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.BuyerTaxNumber) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BuyerTaxNumber') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.BankAccount) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('BankAccount') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.PhoneNum) > 100) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('PhoneNum') + $translate.instant('Output100LengthMsg') + '<br />';
                    stringCount++;
                }

            });

            $scope.outputInvoiceItemList.forEach(function (m) {
                if (PWC.getStringLength(m.CodeVersion) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('CodeVersion') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.ProductName) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('ProductName') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.DocumentNum) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('DocumentNum') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.ProductStandard) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('ProductStandar') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.Unit) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('Unit') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }
                if (PWC.getStringLength(m.TaxClassCode) > 50) {
                    stringLengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxClassCode') + $translate.instant('OutputStringLengthMsg') + '<br />';
                    stringCount++;
                }

                //判断金额是否为数字
                if (isNaN(parseFloat(m.Amount))) {
                    amountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AmountNumberCheckErrorMsg') + '<br />';
                    count3++;
                }
                else if (parseFloat(m.Amount) < constant.startNum || parseFloat(m.Amount) > constant.endNum) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('Amount') + $translate.instant('NumOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }
                else {
                    m.Amount = PWC.round(m.Amount, 2);
                }
                //判断税额是否为数字
                if (isNaN(parseFloat(m.TaxAmount))) {
                    taxAmountNumberCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxAmountNumberCheckErrorMsg') + '<br />';
                    count4++;
                }
                else if (parseFloat(m.TaxAmount) < constant.startNum || parseFloat(m.TaxAmount) > constant.endNum) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxAmount') + $translate.instant('NumOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }
                else {
                    m.TaxAmount = PWC.round(m.TaxAmount, 2);
                }
                //判断单价是否为数字
                if (isNaN(parseFloat(m.UnitPrice))) {
                    unitPriceCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('UnitPriceNumberCheckErrorMsg') + '<br />';
                    unitPriceCount++;
                }
                else if (parseFloat(m.UnitPrice) < constant.startNum || parseFloat(m.UnitPrice) > constant.endNum) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('UnitPrice') + $translate.instant('NumOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }
                else {
                    m.UnitPrice = PWC.round(m.UnitPrice, 2);
                }
                //判断数量是否为正整数字
                if (!PWC.isPositiveInteger(m.Quantity)) {
                    quantityCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('AuantityNumberCheckErrorMsg') + '<br />';
                    count5++;
                }
                else if (parseFloat(m.Quantity) < 1 || parseFloat(m.Quantity) > 9999) {
                    NumlengthMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('Quantity') + $translate.instant('QuantityOverLengthMsg') + '<br />';
                    NumLengthCount++;
                }

                if (constant.outputTaxRate.indexOf(m.TaxRate) === -1) {
                    taxRateCheckMsg += '(' + $translate.instant('RowIndex').formatObj({ rowIndex: m.Index }) + ')' + $translate.instant('TaxRateCheckErrorMsg') + '<br />';
                    count6++;
                }
                else {
                    if (percentList.indexOf(m.TaxRate) > -1) {
                        m.TaxRate = translatePercentNum(m.TaxRate);
                    }
                }
            });

            if (typeCount > 0) {
                $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.OutputInvoiceTypeErrorType,
                   'errorCount': typeCount,
                   'errorContent': typeMsg
               });
            }
            if (count1 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.InvoiceDateErrorType,
                    'errorCount': count1,
                    'errorContent': invoiceDateCheckMsg
                });
            }
            if (count2 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.DateCheckErrorType,
                    'errorCount': count2,
                    'errorContent': invoiceDateRangeCheckMsg
                });
            }
            if (count3 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.AmountNumberCheckErrorType,
                    'errorCount': count3,
                    'errorContent': amountNumberCheckMsg
                });
            }
            if (count4 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.TaxAmountNumberCheckErrorType,
                    'errorCount': count4,
                    'errorContent': taxAmountNumberCheckMsg
                });
            }
            if (count5 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.AuantityNumberCheckErrorType,
                    'errorCount': count5,
                    'errorContent': quantityCheckMsg
                });
            }
            if (count6 > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': validationErrorType.TaxRateCheckErrorType,
                    'errorCount': count6,
                    'errorContent': taxRateCheckMsg
                });
            }
            if (unitPriceCount > 0) {
                $scope.errorMsgMap.push(
                {
                    'errorType': $translate.instant('UnitPriceNumberCheckErrorType'),
                    'errorCount': unitPriceCount,
                    'errorContent': unitPriceCheckMsg
                });
            }
            if (stringCount > 0) {
                $scope.errorMsgMap.push(
               {
                   'errorType': validationErrorType.OutputStringLengthType,
                   'errorCount': stringCount,
                   'errorContent': stringLengthMsg
               });
            }
            if (NumLengthCount > 0) {
                $scope.errorMsgMap.push(
               {
                   'errorType': $translate.instant('NumOutRangeErrorType'),
                   'errorCount': NumLengthCount,
                   'errorContent': NumlengthMsg
               });
            }

        }


        function doImportOutputInvoiceData(importType) {
            $scope.errorMsgMap = [];
            $scope.outputInvoiceList = [];
            $scope.outputInvoiceItemList = [];
            if ($scope.sheetData.dataList.length == 0) {
                SweetAlert.warning($translate.instant('PleaseSelectFileFirst'));
                return;
            }
//            //1.验证模板
//            if (validationIsImportTemp() == false) { //todo : to be open futrue (neo)
//                SweetAlert.error($translate.instant('OutputTempError'));
//                return;
//            }
            //获取数据
            getOutputInvoiceData();
            //日志对象
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = $scope.fileName;
            if (importType === $scope.importEnum.Import) {
                logDto.OperationName = $translate.instant('ImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.Import;
            }
            else if (importType === $scope.importEnum.CoverImport) {
                logDto.OperationName = $translate.instant('CoverImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.CoverImport;
            }
            else if (importType === $scope.importEnum.AddImport) {
                logDto.OperationName = $translate.instant('AddImportOutputInvoice');
                logDto.OperationType = enums.vatLogOperationTypeEnum.AddImport;
            }
            //前台数据验证
//            frontEndValidOutputInvoiceData(); //todo : to be open futrue (neo)
            if ($scope.errorMsgMap.length > 0) {
                $('#errorListModal').modal('show');
                return;
            }
            else {
                vatImportService.importOutputInvoiceData($scope.outputInvoiceList, $scope.outputInvoiceItemList, importType).success(function (or) {
                    if (or && or.result) {
                        logDto.UpdateState = $translate.instant('ImportSuccess');
                        vatOperationLogService.addOperationLog(logDto);

                        initInvoiceDataFromDB($scope.period);
                        $scope.fileName = '';
                        vatCommonService.importSetProjectStatus(projectDbName, curPeriod
                            , constant.DictionaryDictKey.WFImportOutputInvoice, enums.FinishStatusEnum.Finished);
                        vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isOutputInvoiceImport, true);
                        $log.debug("import outputInvoice importOutputInvoiceData: " + vatSessionService.project.importSubStatus.isOutputInvoiceImport);
                        SweetAlert.success($translate.instant('ImportSuccess'));
                    }
                    else {
                        logDto.UpdateState = $translate.instant('ImportFail');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.error($translate.instant('ImportFail'));
                    }
                }).error(function () {
                    logDto.UpdateState = $translate.instant('ImportFail');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            }
        }


        //点击导入按钮时，进行导入操作
        function importOutputInvoiceData(importType) {
            if (vatSessionService.project.projectStatusList[curPeriod] >= constant.ProjectStatusEnum.Generated) {
                swal({
                    title: "warning!",
                    text: $translate.instant('IsConfirmToReImport').formatObj({ status: vatCommonService.getProjectStautsEnumDesc(vatSessionService.project.projectStatusList[curPeriod]) }),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
                function (isConfirm) {
                    if (isConfirm) {
                        doImportOutputInvoiceData(importType);
                    }
                    else {
                        swal.close();
                    }
                });
            }
            else {
                doImportOutputInvoiceData(importType);
            }
        }

        //获取后台验证信息
        function getValidationList() {
            vatImportService.getValidationList(2, $scope.period).success(function (data) {
                if (data.length > 0) {
                    var index = 1;
                    data.forEach(function (v) {
                        v.index = index++;
                    });
                    $scope.errorList = data;
                    $scope.gridOptionsErrorMsg.data = data;

                    showErrTab();
                    $scope.toggleErrorTab();
                    $scope.showErrorTable = true;
                }
                else {
                    $scope.errorList = [];
                    $scope.gridOptionsErrorMsg.data = [];
                    $scope.showErrorTable = false;
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //从数据库获取销项数据
        function initInvoiceDataFromDB(period) {
            $scope.showInitTable = true;
            $scope.showImportTable = false;
            vatSessionService.dataChanged = false;
            $scope.gridOptionsOutputInvoice.data = [];
            $scope.sheetData = { sheetNameList: [], dataList: [], selectedSheetIndex: 0 };
            $scope.invoiceData = [];
            vatImportService.getOutputInvoiceList(period).success(function (rsp) {
                if (rsp.data.length > 0) {
                    $scope.totalCount = rsp.returnCode;
                    $scope.isShowImportTotalBtn = false;
                    initPagingControl(rsp.data.length);
                    var skipCount = ($scope.pagingOptions.pageIndex - 1) * $scope.pagingOptions.pageSize;
                    var pagingData = _.chain(rsp.data).rest(skipCount).first($scope.pagingOptions.pageSize).value();

                    getValidationList();

                    var ouputList = pagingData;//rsp.data;
                    var index = 1;
                    var amountSum = 0;
                    var taxAmountSum = 0;
                    ouputList.forEach(function (v) {
                        if (!_.isNaN(parseFloat(v.amount) && !_.isNaN(parseFloat(v.taxAmount)))) {
                            amountSum += v.amount;
                            taxAmountSum += v.taxAmount;
                        }

                        v.index = index++;
                        v.unitPrice = PWC.round(v.unitPrice, 2);
                        v.amount = PWC.round(v.amount, 2);
                        v.taxRate = PWC.round(v.taxRate, 2);
                        v.taxAmount = PWC.round(v.taxAmount, 2);
                    });
                    $scope.gridOptionsOutputInvoice.data = ouputList;
                    $scope.totalData.totalNumber = ouputList.length;
                    $scope.totalData.amount = PWC.round(amountSum, 2);
                    $scope.totalData.taxAmount = PWC.round(taxAmountSum, 2);
                    initTableTitle();
                }
                else {
                    initTableTitle();
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //显示验证信息
        $scope.toggleErrorTab = function () {
            $scope.ImportErrorTag = !$scope.ImportErrorTag;

            // topIcon and content-resize gapBottom 15px
            if (!$scope.ImportErrorTag) {
                setErrorWrapCssDefault();
            } else {

                if (parseInt($('#content-resizer').css('bottom')) < 100) {
                    $('#content-resizer').css('bottom', '150px');

                    $('#topIcon').css({ bottom: '-381px' });

                    $('.error-info-wrapper').css('height', '150px');
                }
            }
        };

        var setErrorWrapCssDefault = function () {
            $('#content-resizer').css('bottom', '10px');

            $('#topIcon').css({ bottom: '-501px' });

            $('.error-info-wrapper').css('height', '0px');
        };

        function showErrTab() {
            $scope.ImportErrorTab = true;
            $scope.ImportErrorTag = true;
            $scope.errorMsg = $translate.instant('ImportErrorMsg').formatObj({ "NumberOfError": $scope.errorList.length });

        };

        $scope.getGridHeight = function () {
            if ($scope.isLoadComplete) {
                return { height: ($('.balance-ouput-grid-wrapper').height() - 20) + "px" };
            }
            else {
                return { height: 0 + "px" };
            }
        };

        $scope.getErrorGridHeight = function () {
            if ($scope.isLoadComplete) {
                var y = $("#error-info-wrapper").height();
                // Enough space
                if (y > constant.UIGrid.gapHeight) {
                    y = y - constant.UIGrid.gapHeight;
                    return { height: y + "px" };
                } else {

                    return { height: '0px' };
                }
            }
            return {};
        };

        //显示图标
        $scope.errorLevelToString = function (errorLevel) {
            if (errorLevel === 0) {
                return '/app-resources/images/vat/error.png';
            }
            if (errorLevel === 1) {
                return '/app-resources/images/vat/warning.png';
            }
            if (errorLevel === 2) {
                return '/app-resources/images/vat/tips.png';
            }
            else {
                return '/app-resources/images/vat/tips.png';
            }
        }

        //显示明细
        var dealDetail = function () {
            return '<div ng-if="row.entity.isShowDetail === 1" class="ui-grid-cell-contents"><span><a  ng-click="grid.appScope.openTab(row.entity.erpCheckTypeId,row.entity.validationDetails)">查看明细</a><span></div>' +
                    '<div  ng-if="row.entity.isShowDetail !== 1" class="ui-grid-cell-contents" title="{{row.entity.validationDetails}}"><span>{{row.entity.validationDetails}}<span></div>';
        }

        $scope.gridOptionsOutputInvoice = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,

            onRegisterApi: function (gridApi) {
                $scope.gridApi = gridApi;

                $interval(function () {
                    $scope.gridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        //验证信息数据源
        $scope.gridOptionsErrorMsg = {
            rowHeight: constant.UIGrid.rowHeight,
            selectionRowHeaderWidth: constant.UIGrid.selectionRowHeaderWidth,
            enableSorting: false,
            enableColumnMenus: false,
            enableHorizontalScrollbar: uiGridConstants.scrollbars.enableHorizontalScrollbar,
            enableVerticalScrollbar: uiGridConstants.scrollbars.enableVerticalScrollbar,
            columnDefs: [
            {
                name: $translate.instant('Icon'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span><img data-ng-src="{{grid.appScope.errorLevelToString(row.entity.errorLevel)}}"><span></div>'
            },
              {
                  name: $translate.instant('SequenceNo'), width: '5%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
              },
              {
                  name: $translate.instant('ErrorResult'), width: '20%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.validationResult}}<span></div>'
              },
               {
                   name: $translate.instant('ErrorCount'), width: '10%', cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.number}}<span></div>'
               },
              {
                  name: $translate.instant('ErrorDetail'), width: '35%', cellTemplate: dealDetail,
                  //cellTemplate: '<div class="ui-grid-cell-contents">' +
                  //   '<a ng-if="row.entity.isShowDetail" ng-click="grid.appScope.dispalyValidation(row.entity.validationDetails)">{{"ViewDetails" | translate}}</a>' +
                  //   '<span ng-if="!row.entity.isShowDetail" title="{{row.entity.validationDetails}}" data-ng-bind-html="row.entity.validationDetails"></span>' +
                  //   '</div>' 
              },
               {
                   name: $translate.instant('ValidationTips'), width: '25%', cellTemplate: '<div class="ui-grid-cell-contents" title="{{row.entity.validationTips}}"><span>{{row.entity.validationTips}}<span></div>'
               },
            ],
            onRegisterApi: function (gridApi) {
                $scope.errorGridApi = gridApi;

                $interval(function () {
                    $scope.errorGridApi.core.handleWindowResize();
                }, 500, 60 * 60 * 8);
            }
        };

        //初始化列名
        function initTableTitle() {
            $scope.gridOptionsOutputInvoice.columnDefs = [];
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                    {
                                        name: $translate.instant('ImportErrorPopUpNoCol'), width: 50, headerCellClass: 'center',
                                        cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.index}}<span></div>'
                                    });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                   {
                                       name: $translate.instant('InvoiceType'), width: 150, headerCellClass: 'left',
                                       cellTemplate: '<div class="ui-grid-cell-contents"><span>{{grid.appScope.typeToString(row.entity.invoiceType)}}<span></div>'
                                   });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                  {
                                      name: $translate.instant('ClassCode'), width: 150, headerCellClass: 'left',
                                      cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.classCode}}<span></div>'
                                  });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('InvoiceNumber'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceNumber}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('BuyerName'), width: 200, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.buyerName}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('BuyerTaxNumber'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.buyerTaxNumber}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('BankAccount'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.bankAccount}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('PhoneNum'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.phoneNum}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('InvoiceDate'), width: 200, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.invoiceDate | date:"yyyy-MM-dd"}}</span></div>'
                                 });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                 {
                                     name: $translate.instant('CodeVersion'), width: 150, headerCellClass: 'left',
                                     cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.codeVersion}}</span></div>'
                                 });

            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('DocumentNum'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.documentNum}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('ProductName'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.productName}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('ProductStandar'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.productStandard}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('Unit'), width: 150, headerCellClass: 'left',
                                             cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.unit}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('Quantity'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.quantity}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('UnitPrice'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.unitPrice}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('Amount'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.amount}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                         {
                                             name: $translate.instant('TaxRate'), width: 150, headerCellClass: 'right',
                                             cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{grid.appScope.decimalToPercent(row.entity.taxRate)}}</span></div>'
                                         });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                        {
                                            name: $translate.instant('TaxAmount'), width: 150, headerCellClass: 'right',
                                            cellTemplate: '<div class="ui-grid-cell-contents right"><span>{{row.entity.taxAmount}}</span></div>'
                                        });
            $scope.gridOptionsOutputInvoice.columnDefs.push(
                                        {
                                            name: $translate.instant('TaxClassCode'), width: 150, headerCellClass: 'left',
                                            cellTemplate: '<div class="ui-grid-cell-contents"><span>{{row.entity.taxClassCode}}</span></div>'
                                        });

        }

        //清空数据
        var deleteOutputData = function () {
            swal({
                title: "warning!",
                text: $translate.instant('DeleteTbDataTip'),
                type: "warning",
                showCancelButton: true,
                confirmButtonColor: "#DD6B55",
                confirmButtonText: $translate.instant('Yes'),
                cancelButtonText: $translate.instant('No'),
                closeOnConfirm: true,
                closeOnCancel: true
            },
            function (isConfirm) {
                if (isConfirm) {
                    logDto.ID = PWC.newGuid();
                    logDto.CreateTime = new Date();
                    logDto.UpdateTime = new Date();
                    logDto.OperationContent = '';
                    logDto.OperationName = $translate.instant('ClearOutputInvoice');
                    logDto.OperationType = enums.vatLogOperationTypeEnum.ClearData;
                    vatImportService.clearOutputData($scope.period).success(function (data) {
                        if (data && data.result) {

                            $scope.showInitTable = true;
                            $scope.showImportTable = false;
                            $scope.isShowImportTotalBtn = true;
                            $scope.showErrorTable = false;
                            $scope.ImportErrorTab = false;
                            $scope.ImportErrorTag = false;
                            $scope.gridOptionsOutputInvoice.data = [];
                            $scope.totalCount = 0;
                            initTableTitle();
                            logDto.UpdateState = $translate.instant('ClearSuccess');
                            vatOperationLogService.addOperationLog(logDto);
                            vatCommonService.clearProjectStatus(projectDbName, curPeriod
                                , constant.DictionaryDictKey.WFImportOutputInvoice, enums.FinishStatusEnum.NotFinished);
                            vatCommonService.setImportSubStatus(enums.VatImportSubStatus.isOutputInvoiceImport, false);
                            $log.debug("clear outputInvoice importOutputInvoiceData: " + vatSessionService.project.importSubStatus.isOutputInvoiceImport);
                            SweetAlert.success($translate.instant('ClearSuccess'));
                        }
                        else {
                            logDto.UpdateState = $translate.instant('ClearFailed');
                            vatOperationLogService.addOperationLog(logDto);

                            SweetAlert.warning($translate.instant('ClearFailed'));
                        }
                    }).error(function () {
                        logDto.UpdateState = $translate.instant('ClearFailed');
                        vatOperationLogService.addOperationLog(logDto);

                        SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                    });
                }
                else {
                    return;
                }
            });
        }

        //刷新操作
        var refreshOutputData = function () {
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = '';
            logDto.OperationName = $translate.instant('RefreshValidationData');
            logDto.OperationType = enums.vatLogOperationTypeEnum.Refresh;
            //刷新数据
            vatImportService.refreshOutputInvoice($scope.period).success(function (data) {
                if (data && data.result) {
                    logDto.UpdateState = $translate.instant('RefreshSuccess');
                    vatOperationLogService.addOperationLog(logDto);

                    initInvoiceDataFromDB($scope.period);
                    SweetAlert.success($translate.instant('RefreshSuccess'));
                }
                else {
                    logDto.UpdateState = $translate.instant('RefreshTbFail');
                    vatOperationLogService.addOperationLog(logDto);

                    SweetAlert.warning($translate.instant('RefreshTbFail'));
                }
            }).error(function () {
                logDto.UpdateState = $translate.instant('RefreshTbFail');
                vatOperationLogService.addOperationLog(logDto);

                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //显示税额验证信息
        var displayDifferenceValidation = function (sourcedata) {
            $scope.detailData = sourcedata;
            var dupColumns = [
            {
                caption: $translate.instant('InvoiceType'),
                calculateCellValue: function (data) {
                    return $scope.typeToString(data.InvoiceType);
                }
            },
            { caption: $translate.instant('ClassCode'), dataField: "ClassCode" },
            { caption: $translate.instant('InvoiceNumber'), dataField: "InvoiceNumber" },
            { caption: $translate.instant('Amount'), dataField: "Amount", format: { type: 'fixedPoint', precision: 2 } },
            { caption: $translate.instant('TaxAmount'), dataField: "TaxAmount", format: { type: 'fixedPoint', precision: 2 } },
            {
                caption: $translate.instant('TaxRate'), dataField: "TaxRate",
                calculateCellValue: function (data) {
                    return $scope.decimalToPercent(data.TaxRate);
                }
            },
            //{ caption: $translate.instant('AmountDifference'), dataField: "AmountDifference", format: { type: 'fixedPoint', precision: 2 }, width: 100 }, 
            ];

            $scope.deferStatus = true;
            $scope.filterCondition = ["IsDuplicate", "=", true];
            $scope.gridDifferenceOptions = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource": "detailData"
                },
                hoverStateEnabled: true,
                noDataText: $translate.instant('AccountVoucher_DataGrid_NoDataText'),
                paging: {
                    pageSize: 10
                }
            }
            $('#differenceValidationModal').modal('show');
        }

        //显示重复验证明细界面
        var dispalyDuplicatedValidation = function (sourcedata) {
            $scope.detailData = sourcedata;
            var dupColumns = [
            {
                caption: $translate.instant('InvoiceType'), width: 150,
                calculateCellValue: function (data) {
                    return $scope.typeToString(data.InvoiceType);
                }
            },
            { caption: $translate.instant('ClassCode'), dataField: "ClassCode", width: 150 },
            { caption: $translate.instant('InvoiceNumber'), dataField: "InvoiceNumber", width: 150 },
            { caption: $translate.instant('BuyerName'), dataField: "BuyerName", width: 200 },
            { caption: $translate.instant('BuyerTaxNumber'), dataField: "BuyerTaxNumber", width: 200 },
            { caption: $translate.instant('BankAccount'), dataField: "BankAccount", width: 150 },
            { caption: $translate.instant('PhoneNum'), dataField: "PhoneNum", width: 150 },
            { caption: $translate.instant('InvoiceDate'), dataField: "InvoiceDate", dataType: "date", width: 150 }, ];

            $scope.deferStatus = true;
            $scope.filterCondition = ["IsDuplicate", "=", true];
            $scope.gridDuplicatedOptions = {
                columns: dupColumns,
                bindingOptions: {
                    "dataSource.store.data": "detailData",
                    "selection.deferred": "deferStatus",
                    "selectionFilter": "filterCondition"
                },
                dataSource: {
                    store: {
                        type: "array",
                        key: 'InvoiceID'
                    }
                },
                selection: {
                    mode: "multiple",
                    selectAllMode: "allPages",
                    showCheckBoxesMode: "always",
                },
                hoverStateEnabled: true,
                paging: {
                    pageSize: 10
                },
            }
            $('#duplicatedValidationModal').modal('show');
        }

        //验证信息
        $scope.openTab = function (errorType, rowdata) {
            var data = JSON.parse(rowdata);
            if (errorType === 81) {
                displayDifferenceValidation(data);
            }
            else if (errorType === 80) {
                dispalyDuplicatedValidation(data);
            }
        }

        //删除重复数据
        var deleteDupData = function () {
            var dataGrid = $('#gridDuplicatedValidation').dxDataGrid("instance");
            var deleteList = [];
            dataGrid.getSelectedRowsData().done(function (rowData) {
                for (var i = 0; i < rowData.length; i++) {
                    deleteList.push(rowData[i].ClassCode);
                }
            });
            dataGrid.getSelectedRowKeys().done(function (keys) {
                if (keys && keys.length === 0) {
                    SweetAlert.warning($translate.instant('DeleteEmptyWarning'));
                    return;
                }

                logDto.ID = PWC.newGuid();
                logDto.CreateTime = new Date();
                logDto.UpdateTime = new Date();
                logDto.OperationContent = deleteList.join(",");
                logDto.OperationName = $translate.instant('DeleteDuplicateData');
                logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteDuplicate;

                vatImportService.deleteOutputDupData(keys).success(function (rsp) {
                    if (rsp && rsp.result) {
                        vatOperationLogService.addOperationLog(logDto);
                        //刷新数据
                        vatImportService.refreshOutputInvoice($scope.period).success(function (data) {
                            if (data && data.result) {
                                $('#duplicatedValidationModal').modal('hide');
                                SweetAlert.success($translate.instant('DeleteSuccess'));
                                initInvoiceDataFromDB($scope.period);
                            }
                            else {
                                SweetAlert.warning($translate.instant('RefreshTbFail'));
                            }
                        }).error(function () {
                            SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                        });
                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            });
        }
        //日志
        $scope.showOperateLogPop = function () {
            $scope.isShowLog = true;
        };

        /****************************************证据文件function start*************************************************/
        var evidenceCount = 0;
        var allFilesCount = 0;
        var orderfileName = true;
        var orderperiodId = true;
        var orderfileType = true;
        $scope.chunkEvidenceSize = 10 * 1024 * 1024;
        var uploadEvidenceUrl = apiInterceptor.vatWebApiHostUrl + '/outputInvoiceImport/UploadEvidenceFile';
        //上传文件
        var uploadEvidenceFile = function (files) {
            if (files && files.length) {
                allFilesCount = files.length;
                evidenceCount = 0;
                for (var i = 0; i < files.length; i++) {
                    var file = files[i];
                    if (!file.$error) {
                        var tempFileName = PWC.newGuid() + '.dat';
                        var token = $('input[name="__RequestVerificationToken"]').val();
                        Upload.upload({
                            url: uploadEvidenceUrl,
                            data: {
                                cancel: false,
                                filename: file.name,
                                tempFileName: tempFileName,
                                file: file,
                                period: $scope.period
                            },
                            resumeChunkSize: resumable ? chunkSize : null,
                            headers: {
                                'Access-Control-Allow-Origin': '*',
                                Authorization: apiInterceptor.tokenType + ' ' + apiInterceptor.apiToken(),
                                from: vatSessionService.project.id
                            },
                            __RequestVerificationToken: token,
                            withCredentials: true
                        }).then(uploadEvidenceSuccess);
                    }
                }
            }
        };
        //上传成功
        var uploadEvidenceSuccess = function (resp) {
            if (resp.data) {
                evidenceCount++;
                if (evidenceCount === allFilesCount) {
                    addEvidenceLog();
                    SweetAlert.success($translate.instant('UploadFileSuccess'));
                    searchEvidence();
                }
            }
        };

        //上传证据文件日志
        function addEvidenceLog() {
            var filename = ''
            if ($scope.evidenceFile.length > 0) {
                $scope.evidenceFile.forEach(function (m) {
                    filename += m.name + ';';
                });
            }
            //日志对象
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = filename;
            logDto.OperationName = $translate.instant('ImportEvidence');
            logDto.OperationType = enums.vatLogOperationTypeEnum.AddData;
            logDto.UpdateState = $translate.instant('UploadFileSuccess');
            vatOperationLogService.addOperationLog(logDto);
        }

        //删除证据文件日志
        function deleteEvidenceLog(deleteName) {
            //日志对象
            logDto.ID = PWC.newGuid();
            logDto.CreateTime = new Date();
            logDto.UpdateTime = new Date();
            logDto.OperationContent = deleteName;
            logDto.OperationName = $translate.instant('DeleteEvidence');
            logDto.OperationType = enums.vatLogOperationTypeEnum.DeleteData;
            logDto.UpdateState = $translate.instant('DeleteSuccess');
            vatOperationLogService.addOperationLog(logDto);
        }

        //验证导入文件数量和大小
        function validationEvidenceFile(files) {
            var isOk = true;
            $scope.evidenceMsgMap = [];
            var sizeString = '';
            var exString = '';
            var sizeCount = 0;
            var exCount = 0;
            if (files.length > 5) {
                $scope.evidenceMsgMap.push(
                       {
                           'errorType': $translate.instant('OutOfAmountType'),
                           'errorCount': files.length,
                           'errorContent': $translate.instant('OutOfAmount')
                       });
            }
            if (files.length > 0) {
                for (var i = 0; i < files.length; i++) {
                    var file = files[i];
                    var fileSize = file.size;
                    var fileExtension = files[i].name.split('.').pop().toLowerCase();
                    //大小不能超过10M
                    if (fileSize > $scope.chunkEvidenceSize) {
                        sizeString += files[i].name + ',';
                        sizeCount++;
                    }
                    if (fileExtension === 'exe') {
                        exString += files[i].name + ',';
                        exCount++;
                    }
                }
                if (sizeString) {
                    $scope.evidenceMsgMap.push(
                      {
                          'errorType': $translate.instant('OutOfSizeType'),
                          'errorCount': sizeCount,
                          'errorContent': $translate.instant('OutOfSize').formatObj({ rows: sizeString.substring(0, sizeString.length - 1) })
                      });
                }
                if (exString) {
                    $scope.evidenceMsgMap.push(
                      {
                          'errorType': $translate.instant('ErrorFileType'),
                          'errorCount': exCount,
                          'errorContent': $translate.instant('ErrorFileMsg'),
                      });
                }
            }
            if ($scope.evidenceMsgMap.length > 0) {
                $('#evidenceErrorListModal').modal('show');
                isOk = false;
            }
            return isOk;
        }

        //查询证据文件
        function searchEvidence() {
            $scope.evidenceList = [];
            var queryParams = {
                queryType: $scope.queryType,
                queryString: $scope.queryString,
                isCurrentPeriod: $scope.isCurrentPeriod,
                periodId: $scope.period
            };
            vatImportService.getEvidenceList(queryParams).success(function (data) {
                if (data.length > 0) {
                    $scope.evidenceList = data;
                    $scope.evidenceTotalCount = '(' + data.length + ')';
                }
                else if (data.length === 0) {
                    $scope.evidenceTotalCount = '';
                }
            }).error(function () {
                SweetAlert.error($translate.instant('PleaseContactAdministrator'));
            });
        }

        //查询文件数量
        function getEvidenceTitle() {
            searchEvidence();
            if ($scope.evidenceList.length > 0) {
                return $translate.instant('EvidenceTab') + '(' + $scope.evidenceList.length + ')';
            }
            else {
                return $translate.instant('EvidenceTab');
            }
        }

        //单击选中文件
        function selectEvidenceFile(evidence) {
            if ($scope.clicked) {
                $scope.cancelClick = true;
                return;
            }
            $scope.clicked = true;
            $timeout(function () {
                if ($scope.cancelClick) {
                    $scope.cancelClick = false;
                    $scope.clicked = false;
                    return;
                }
                evidence.isSelected = !evidence.isSelected;
                //clean up
                $scope.cancelClick = false;
                $scope.clicked = false;
            }, 300);
        }
        //下载
        $scope.openEvidenceFile = function (evidence) {
            var filePath = evidence.filePath;
            var fileName = evidence.fileName;
            $timeout(function (evidence) {
                var queryParams = {
                    filePath: filePath,
                    fileName: fileName
                };
                vatImportService.downloadEvidence(queryParams).success(function (data, status, headers) {
                    var octetStreamMime = 'application/octet-stream';
                    var contentType = headers('content-type') || octetStreamMime;
                    if (window.navigator.msSaveBlob) {

                        var blob = new Blob([data], {
                            type: contentType
                        });
                        navigator.msSaveBlob(blob, fileName);
                    } else {
                        var urlCreator = window.URL || window.webkitURL || window.mozURL || window.msURL;
                        if (urlCreator) {
                            var a = document.createElement('a');
                            var blob = new Blob([data], {
                                type: contentType
                            });
                            var url = urlCreator.createObjectURL(blob);
                            a.href = url;
                            a.target = '_blank';
                            a.download = fileName;
                            document.body.appendChild(a);
                            a.click();
                        }
                    }
                }).error(function () {
                    SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                });
            });
        }

        //删除文件
        function deleteEvidenceFiles() {
            var deleteList = [];
            var deleteName = '';
            $scope.evidenceList.forEach(function (m) {
                if (m.isSelected) {
                    deleteList.push(m.fileID);
                    deleteName += m.fileName + ';';
                }
            });
            if (deleteList.length > 0) {
                SweetAlert.
                swal({
                    title: "warning!",
                    text: $translate.instant('IsDelete'),
                    type: "warning",
                    showCancelButton: true,
                    confirmButtonColor: "#DD6B55",
                    confirmButtonText: $translate.instant('Yes'),
                    cancelButtonText: $translate.instant('No'),
                    closeOnConfirm: true,
                    closeOnCancel: true
                },
              function (isConfirm) {
                  if (isConfirm) {
                      vatImportService.deleteEvidences(deleteList).success(function (data) {
                          if (data) {
                              deleteEvidenceLog(deleteName);
                              searchEvidence();
                          }
                      }).error(function () {
                          SweetAlert.error($translate.instant('PleaseContactAdministrator'));
                      });
                  }
              });
            }
        }

        //排序方法
        var dataType = {
            isPrefixNumber: function (value) {
                var reg = /^\d+/;
                if (reg.test(value)) {
                    return true;
                } else {
                    return false;
                }
            },
            isPrefixChar: function (value) {
                var reg = /^[a-zA-Z]+/;
                if (reg.test(value)) {
                    return true;
                } else {
                    return false;
                }
            },
            isPrefixNumberOrChar: function (value) {
                if (dataType.isPrefixNumber(value)) {
                    return true;
                }
                if (dataType.isPrefixChar(value)) {
                    return true;
                }
                return false;
            }
        }

        var sortByFileName = function (data) {
            if (data && data.length > 0) {

                var charList = [];
                var nocharList = [];

                data.forEach(function (row) {
                    if (dataType.isPrefixNumberOrChar(row.fileName)) {
                        row.nameSort = row.fileName;

                        if (row.nameSort) {
                            row.nameSort = row.nameSort.toLowerCase();
                        }

                        charList.push(row);

                    } else {
                        nocharList.push(row);
                    }

                });

                charList = _.sortBy(charList, 'nameSort');

                nocharList = nocharList.sort(function compareFunction(param1, param2) {
                    return param1.fileName.localeCompare(param2.fileName, 'zh');
                });

                var all = _.union(charList, nocharList);
                return all;
            }
            return data;
        };

        //排序
        function fileSort(i) {
            if ($scope.evidenceList.length > 0) {
                if (i == 0) {
                    if (orderfileName) {
                        orderfileName = false;
                        var list = sortByFileName($scope.evidenceList);
                        //var list = _.sortBy($scope.evidenceList, 'fileName');                       
                        //var list = list.sort(function (x, y) { return x['name'].localeCompare(y['name']) }); 
                        $scope.evidenceList = list;
                    }
                    else {
                        orderfileName = true;
                        //var list = _.sortBy($scope.evidenceList, 'fileName');
                        var list = sortByFileName($scope.evidenceList);
                        $scope.evidenceList = list.reverse();
                    }
                }
                if (i == 1) {
                    if (orderperiodId) {
                        orderperiodId = false;
                        var list = _.sortBy($scope.evidenceList, 'periodID');
                        $scope.evidenceList = list;
                    }
                    else {
                        orderperiodId = true;
                        var list = _.sortBy($scope.evidenceList, 'periodID');
                        $scope.evidenceList = list.reverse();
                    }
                }
                if (i == 2) {
                    if (orderfileType) {
                        orderfileType = false;
                        var list = _.sortBy($scope.evidenceList, 'fileType');
                        $scope.evidenceList = list;
                    }
                    else {
                        orderfileType = true;
                        var list = _.sortBy($scope.evidenceList, 'fileType');
                        $scope.evidenceList = list.reverse();
                    }
                }
            }

        }

        //控制明细信息中删除权限
        var getUserPermission = function () {
            var list = [];
            var code = constant.vatPermission.dataImport.outputInvoice.importCode;
            list.push(code);

            $scope.$root.checkUserOrganizationPermissionList(list).success(function (data) {
                $scope.hasEditPermission = data[code];
            });
        };

        var initPagingControl = function (totalItemsCount) {
            $scope.pagingOptions.totalItems = totalItemsCount;
        }

        $scope.pagingService = {
            refreshInvoiceDataGrid: function () {
                $log.debug("refreshInvoiceDataGrid");
                initInvoiceDataFromDB($scope.period);
            },
        };

        var setButtonWrapStyle = function () {
            if ($scope.showImportTable) {
                return { width: "100%" };
            }
        };

        //开始
        (function initialize() {
            $log.debug('ImportOutputInvoiceController.ctor()...');
            /****************************************销项发票function start*************************************************/

            $scope.switchTab = switchTab;
            $scope.changeSheet = changeSheet;
            $scope.importOutputInvoiceData = importOutputInvoiceData;
            $scope.refreshOutputData = refreshOutputData;
            $scope.deleteOutputData = deleteOutputData;
            $scope.deleteDupData = deleteDupData;

            getUserPermission();
            initInvoiceDataFromDB($scope.period);
            $scope.$watch('fileNameWrapper', function (newValue, oldValue) {
                if (newValue != null && newValue !== oldValue) {
                    //设置上传文件名
                    var arr = newValue.name.split('.');
                    if (arr[arr.length - 1] !== 'xls' && arr[arr.length - 1] !== 'xlsx') {
                        SweetAlert.warning($translate.instant('ImportFileInvalidType'));
                        return;
                    }
                    $scope.fileName = newValue.name;
                    uploadfile($scope.fileNameWrapper);
                    $scope.ImportErrorTab = false;
                    $scope.ImportErrorTag = false;
                }
            });

            /****************************************证据文件function start*************************************************/
            $scope.evidenceList = [];
            $scope.isCurrentPeriod = true;
            $scope.queryType = '';
            $scope.queryString = '';
            $scope.searchEvidence = searchEvidence;
            $scope.selectEvidenceFile = selectEvidenceFile;
            $scope.deleteEvidenceFiles = deleteEvidenceFiles;
            $scope.getEvidenceTitle = getEvidenceTitle;
            $scope.fileSort = fileSort;
            $scope.setButtonWrapStyle = setButtonWrapStyle;
            searchEvidence();
            $scope.$watch('evidenceFile', function (newValue, oldValue) {
                if (newValue != null && newValue !== oldValue) {
                    //验证文件数量和大小
                    if (validationEvidenceFile($scope.evidenceFile)) {
                        uploadEvidenceFile($scope.evidenceFile);
                    }
                }
            });

            $timeout(function () {
                $scope.isLoadComplete = true;
            }, 500);

        })();
    }
]);